Imports System.IO

Public Class ClassLogger
    Private Shared DateiSpeicherort As String = Nothing
    Private Shared DateiPrefix As String = ""
    Private Shared Datei As IO.File = Nothing
    Private Shared Dateiname As String = ""
    Private Shared StreamWriter As IO.StreamWriter = Nothing
    Private Shared HasInformedAboutError As Boolean = False
    ' eine Art Konstruktor
    Public Shared Sub Init(ByVal speicherort As String, Optional ByVal prefix As String = "", Optional ByVal appendFile As Boolean = True)
        ClassLogger.DateiSpeicherort = speicherort
        ' wenn ein Prfix gesetzt wurde
        If Not prefix = "" Then
            ' initialisiert das Prefix
            ClassLogger.SetPrefix(prefix)
        End If
        Dim str As String = ClassLogger.DateiSpeicherort & "\" & ClassLogger.DateiPrefix & System.DateTime.Now.ToString("yyyy_MM_dd") & ".txt"
        Dim anz As Integer = 1
        Do While File.Exists(str)
            Dim info As New FileInfo(str)
            Dim length As Long = info.Length
            If length > 5000000 Then
                str = IO.Path.GetDirectoryName(str)
                str = str & "\" & ClassLogger.DateiPrefix & System.DateTime.Now.ToString("yyyy_MM_dd") & "(" & anz.ToString & ").txt"
                anz = anz + 1
            Else
                Exit Do
            End If
        Loop
        ClassLogger.Dateiname = str
        If Not appendFile Then
            ' der Versuch die Datei zu löschen
            'Try
            '    My.Computer.FileSystem.DeleteFile(ClassNILogger.Dateiname, FileIO.UIOption.OnlyErrorDialogs, FileIO.RecycleOption.DeletePermanently)
            'Catch ex As Exception
            '    ' bei Fehler besteht kein Schreibrecht auf die Datei oder Datei existiert nicht
            '    ' ALSO: alles Okay soweit
            'End Try
            My.Computer.FileSystem.WriteAllText(ClassLogger.Dateiname, "Neu erstellt - appendfile", False)
        End If
        ' testen ob sich die Datei öffnen und beschreiben lässt
        'ClassNILogger.CheckIsLogWritable()
    End Sub

    ' legt den Speicherort fest
    Public Shared Sub SetSpeicherort()
        Dim f As New IO.DirectoryInfo(My.Application.Info.DirectoryPath & "\Log")
        If f.Exists = False Then
            IO.Directory.CreateDirectory(My.Application.Info.DirectoryPath & "\Log")
        End If
        ClassLogger.DateiSpeicherort = My.Application.Info.DirectoryPath & "\Log\"
       
    End Sub

    ' legt das Prefix für den Dateinamen fest
    Public Shared Sub SetPrefix(ByVal prefix As String)
        ClassLogger.DateiPrefix = prefix
    End Sub

    Public Shared Sub Add(ByVal text As String, ByVal _error As Boolean, Optional ByVal Funktion As String = "")
        If ClassLogger.OpenFile Then
            Try
                Dim msg As String
                If _error = True And Funktion <> "" Then
                    msg = ">> Achtung Fehler in Funktion '" & Funktion & "'" & vbNewLine
                ElseIf _error = True Then
                    msg = ">> Achtung Fehler:" & vbNewLine
                End If
                msg &= text

                ClassLogger.StreamWriter.WriteLine(msg)
                ClassLogger.CloseFile()
            Catch e As Exception
                ClassLogger.WriteErrorMessage()
            End Try
        Else
            ClassLogger.WriteErrorMessage()
        End If
    End Sub
    Public Shared Sub AddDetailLog(ByVal text As String)
        If ClassLogger.OpenFile Then
            Try
                If clsSQLITE.konf_logerrorsonly = False Then
                    ClassLogger.StreamWriter.WriteLine("*" & text)
                    ClassLogger.CloseFile()
                End If
            Catch e As Exception
                ClassLogger.WriteErrorMessage()
            End Try
        Else
            ClassLogger.WriteErrorMessage()
        End If
    End Sub
    ' öffnet eine Datei zum Schreiben
    Private Shared Function OpenFile()
        Try
            ' wenn ein Speicherort festgelegt wurde
            If Not ClassLogger.DateiSpeicherort = Nothing Then
                ' den Dateienamen definieren
                Dim dateiname As String = ClassLogger.Dateiname
                ' Datei anlegen wenn noch nicht vorhanden
                My.Computer.FileSystem.WriteAllText(dateiname, String.Empty, True)
                ' die Datei zum Schreiben öffnen
                ClassLogger.StreamWriter = New IO.StreamWriter(dateiname, True, System.Text.Encoding.UTF8)
            End If
            ' wenn die Datei erfolgreich geöffnet wurde
            If ClassLogger.StreamWriter IsNot Nothing Then
                Return True
            Else
                Return False
            End If
        Catch ex As Exception
            Return False
        End Try

    End Function

    ' öffnet eine Datei zum Schreiben
    Private Shared Function OpenFile(ByVal DateiSpeicherort As String, ByVal DateiPrefix As String)
        Try
            ' wenn ein Speicherort festgelegt wurde
            If Not DateiSpeicherort = Nothing And ClassLogger.CheckIsLogWritable() Then
                ' den Dateienamen definieren
                Dim dateiname As String = ClassLogger.Dateiname
                ' Datei anlegen wenn noch nicht vorhanden
                My.Computer.FileSystem.WriteAllText(dateiname, String.Empty, True)

                ' die Datei zum Schreiben öffnen
                ClassLogger.StreamWriter = New IO.StreamWriter(dateiname, True, System.Text.Encoding.UTF8)
            End If
            ' wenn die Datei erfolgreich geöffnet wurde
            If ClassLogger.StreamWriter IsNot Nothing Then
                Return True
            Else
                Return False
            End If

        Catch ex As Exception
            Return False
        End Try

    End Function


    ' schliesst die geöffnete Datei
    Private Shared Sub CloseFile()

        ' wenn eine Datei geöffnet ist
        If ClassLogger.StreamWriter IsNot Nothing Then
            ' die Datei schliessen
            ClassLogger.StreamWriter.Close()
            ClassLogger.StreamWriter = Nothing
        End If
    End Sub


    Public Shared Function CheckIsLogWritable()

        If ClassLogger.OpenFile Then
            Try
                ClassLogger.CloseFile()
            Catch e As Exception
                ClassLogger.WriteErrorMessage()
                Return False
            End Try
        Else
            ClassLogger.WriteErrorMessage()
            Return False
        End If

        Return True
    End Function


    Public Shared Function CheckIsLogWritable(ByVal vDateiSpeicherort As String, ByVal vDateiPrefix As String)

        If ClassLogger.OpenFile(vDateiSpeicherort, vDateiPrefix) Then
            Try
                ClassLogger.CloseFile()
            Catch e As Exception
                ClassLogger.WriteErrorMessage()
                Return False
            End Try
        Else
            ClassLogger.WriteErrorMessage()
            Return False
        End If

        Return True
    End Function


    Private Shared Sub WriteErrorMessage()
        If Not ClassLogger.HasInformedAboutError Then
            clsSQLITE.Execute_non_Query("INSERT INTO TBLOG (MODUL,MESSAGE) VALUES ('MAIN','" & "Fehler beim Öffnen der Logdatei - Keine Schreibrechte im Verzeichnis? Es wird keine Logdatei angelegt oder beschrieben.")
            'MsgBox("Beim Öffnen der Logdatei ist ein Fehler aufgetreten. Bitte stellen Sie sicher das Sie sowohl über entsprechende Schreibrechte im Verzeichnis, als auch über ausreichend Speicherplatz zum Speichern der Logdatei verfügen." & _
            '       vbNewLine & vbNewLine & "Es wird keine Logdatei angelegt oder beschrieben." & vbNewLine & vbNewLine & "Im folgenden werden Sie über Fehler, den Log betreffend nicht weiter informiert, um den Ablauf des Dateiimporters nicht zu stören.", _
            '       MsgBoxStyle.Information, "Fehler beim Öffnen der Logdatei")
            ClassLogger.HasInformedAboutError = True
        End If
    End Sub

End Class
